From 5fd3a04790ecc6ea9b8a5c9d0a3bc9765fb83195 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 21 2017 13:40:40 +0000
Subject: [PATCH 866/1001] Make the Feed component more reusable


---

diff --git a/hubs/static/client/app/components/feed/Actions.jsx b/hubs/static/client/app/components/feed/Actions.jsx
new file mode 100644
index 0000000..c481377
--- /dev/null
+++ b/hubs/static/client/app/components/feed/Actions.jsx
@@ -0,0 +1,78 @@
+import React from 'react';
+
+
+export default class Actions extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.save = this.save.bind(this);
+    this.delete = this.delete.bind(this);
+  }
+
+  save() {
+    const payload = {
+      link: this.props.item.link,
+      markup: this.props.item.markup,
+      secondary_icon: this.props.item.secondary_icon,
+      dom_id: this.props.item.dom_id,
+    };
+
+    $.ajax({
+      type: 'POST',
+      url: this.props.options.saveUrl,
+      data: JSON.stringify(payload),
+      contentType: 'application/json',
+    }).done(() => {
+      const id = `#save-${this.props.item.dom_id}`;
+      const $saveBtn = $(id);
+      $saveBtn.removeClass('btn-primary').addClass('btn-success');
+      $saveBtn.text('Saved');
+    });
+  }
+
+  delete() {
+    $.ajax({
+      type: 'DELETE',
+      url: `${this.props.options.saveUrl}${this.props.item.idx}/`,
+    }).done((resp) => {
+      if (resp.status_code === 200) {
+        const $notification = $(`#${this.props.item.dom_id}`);
+        $notification.closest('.card-block').remove();
+      }
+    });
+  }
+
+  render() {
+    var buttonProps = {
+      id: `save-${this.props.item.dom_id}`,
+      className: "btn btn-sm ",
+    };
+    var buttonText;
+
+    if (this.props.item.saved) {
+      if (this.props.options.delete) {
+        buttonProps.className += "btn-danger";
+        buttonProps.onClick = this.delete;
+        buttonText = "Remove";
+      } else {
+        buttonText = "Saved";
+      }
+    } else {
+      buttonProps.className += "btn-primary";
+      buttonProps.onClick = this.save;
+      buttonText = "Save";
+    }
+
+    return (
+      <div className="float-right">
+        <button {...buttonProps}>
+          {buttonText}
+        </button>
+      </div>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/feed/Feed.jsx b/hubs/static/client/app/components/feed/Feed.jsx
new file mode 100644
index 0000000..464e2e1
--- /dev/null
+++ b/hubs/static/client/app/components/feed/Feed.jsx
@@ -0,0 +1,24 @@
+import React from 'react';
+import Panel from './Panel.jsx';
+
+
+export default class Feed extends React.Component {
+
+  render() {
+    var items = this.props.items || [];
+    items = items.map((item, idx) => {
+      return (
+        <Panel item={item} {...this.props} key={idx} />
+        );
+    });
+    return (
+      <div>
+        {items}
+      </div>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/feed/Icon.jsx b/hubs/static/client/app/components/feed/Icon.jsx
new file mode 100644
index 0000000..a81f41c
--- /dev/null
+++ b/hubs/static/client/app/components/feed/Icon.jsx
@@ -0,0 +1,21 @@
+import React from 'react';
+
+class Icon extends React.Component {
+  render() {
+    return (
+      <div>
+        <div className="media-left">
+          <a href={this.props.item.link ? this.props.item.link : '#'} target="_blank">
+            <img
+              alt="User avatar"
+              className="media-object square-32 img-circle"
+              src={this.props.item.secondary_icon}
+            />
+          </a>
+        </div>
+      </div>
+    );
+  }
+}
+
+export default Icon;
diff --git a/hubs/static/client/app/components/feed/Markup.jsx b/hubs/static/client/app/components/feed/Markup.jsx
new file mode 100644
index 0000000..daf2d84
--- /dev/null
+++ b/hubs/static/client/app/components/feed/Markup.jsx
@@ -0,0 +1,36 @@
+import React from 'react';
+import Actions from './Actions.jsx';
+import TimeAgo from 'react-timeago';
+
+
+export default class Markup extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.createMarkup = this.createMarkup.bind(this);
+  }
+
+  createMarkup() {
+    return { __html: this.props.item.markup };
+  }
+
+  render() {
+    const timestamp = this.props.item.date_time ? (<TimeAgo date={this.props.item.date_time} />) : null;
+
+    return (
+      <div className="media-body">
+        <h4
+          className="media-heading"
+          dangerouslySetInnerHTML={this.createMarkup()}
+        >
+        </h4>
+        {timestamp}
+        <Actions {...this.props} />
+      </div>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/feed/Panel.jsx b/hubs/static/client/app/components/feed/Panel.jsx
new file mode 100644
index 0000000..eb0128b
--- /dev/null
+++ b/hubs/static/client/app/components/feed/Panel.jsx
@@ -0,0 +1,22 @@
+import React from 'react';
+import Icon from './Icon.jsx';
+import Markup from './Markup.jsx';
+
+
+export default class Panel extends React.Component {
+
+  render() {
+    return (
+      <div className="card">
+        <div className="card-block" id={this.props.item.id}>
+          <Icon item={this.props.item} />
+          <Markup {...this.props} />
+        </div>
+      </div>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/feed/__tests__/Feed.test.js b/hubs/static/client/app/components/feed/__tests__/Feed.test.js
new file mode 100644
index 0000000..a3e8365
--- /dev/null
+++ b/hubs/static/client/app/components/feed/__tests__/Feed.test.js
@@ -0,0 +1,30 @@
+/* eslint-env jasmine, jest */
+
+jest.unmock('../Feed.jsx');
+
+import React from 'react';
+import ReactDOM from 'react-dom';
+import TestUtils from 'react-addons-test-utils';
+
+import Feed from '../Feed.jsx';
+
+describe('Feed', () => {
+  const item = {
+    markup: '<a href="https://pagure.io/fedora-hubs">Link</a>',
+    date_time: new Date(),
+    link: 'https://pagure.io/fedora-hubs',
+    secondary_icon: 'https://placekitten.com/g/200/300',
+  }
+  const items = [item, item, item];
+
+  it('should create the children', () => {
+    const component = TestUtils.renderIntoDocument(
+      <Feed items={items} messageLimit={100} />
+    );
+    const node = ReactDOM.findDOMNode(component);
+    expect(node.children.length).toEqual(3);
+  });
+});
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/feed/__tests__/Icon.test.js b/hubs/static/client/app/components/feed/__tests__/Icon.test.js
new file mode 100644
index 0000000..72dadc5
--- /dev/null
+++ b/hubs/static/client/app/components/feed/__tests__/Icon.test.js
@@ -0,0 +1,39 @@
+/* eslint-env jasmine, jest */
+
+jest.unmock('../Icon.jsx');
+
+import React from 'react';
+import ReactDOM from 'react-dom';
+import TestUtils from 'react-addons-test-utils';
+
+import Icon from '../Icon.jsx';
+
+describe('Icon', () => {
+  const item = {
+    link: 'https://pagure.io/fedora-hubs',
+    secondary_icon: 'https://placekitten.com/g/200/300',
+  };
+
+  it('has the correct link', () => {
+    const component = TestUtils.renderIntoDocument(
+      <Icon item={item} />
+    );
+    expect(component).toBeTruthy();
+    const node = ReactDOM.findDOMNode(component);
+    const link = node.querySelector('a');
+    expect(link.getAttribute('href')).toEqual(item.link);
+  });
+  it('has the correct image source', () => {
+    const component = TestUtils.renderIntoDocument(
+      <Icon item={item} />
+    );
+    expect(component).toBeTruthy();
+
+    const node = ReactDOM.findDOMNode(component);
+    const image = node.querySelector('img');
+    expect(image.getAttribute('src')).toEqual(item.secondary_icon);
+  });
+});
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/feed/__tests__/Markup.test.js b/hubs/static/client/app/components/feed/__tests__/Markup.test.js
new file mode 100644
index 0000000..31d336d
--- /dev/null
+++ b/hubs/static/client/app/components/feed/__tests__/Markup.test.js
@@ -0,0 +1,33 @@
+/* eslint-env jasmine, jest */
+
+jest.unmock('../Markup.jsx');
+
+import React from 'react';
+import ReactDOM from 'react-dom';
+import TestUtils from 'react-addons-test-utils';
+
+import Markup from '../Markup.jsx';
+
+describe('Markup', () => {
+  const item = {
+    markup: '<a href="https://pagure.io/fedora-hubs">Link</a>',
+    date_time: new Date(),
+  };
+
+  it('should set the inner html of the markup', () => {
+    const component = TestUtils.renderIntoDocument(
+      <Markup item={item} />
+    );
+    expect(component).toBeTruthy();
+
+    const node = ReactDOM.findDOMNode(component);
+    const header = node.querySelector('h4');
+
+    expect(header.innerHTML).toEqual(item.markup);
+  });
+
+  // we don't test TimeAgo, the library should have its own tests
+});
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/feed/__tests__/Panel.test.js b/hubs/static/client/app/components/feed/__tests__/Panel.test.js
new file mode 100644
index 0000000..6e17d1c
--- /dev/null
+++ b/hubs/static/client/app/components/feed/__tests__/Panel.test.js
@@ -0,0 +1,33 @@
+/* eslint-env jasmine, jest */
+
+jest.unmock('../Panel.jsx');
+
+import React from 'react';
+import ReactDOM from 'react-dom';
+import TestUtils from 'react-addons-test-utils';
+
+import Panel from '../Panel.jsx';
+
+describe('Panel', () => {
+  const item = {
+    markup: '<a href="https://pagure.io/fedora-hubs">Link</a>',
+    date_time: new Date(),
+    link: 'https://pagure.io/fedora-hubs',
+    secondary_icon: 'https://placekitten.com/g/200/300',
+  };
+
+  it('should render the card block', () => {
+    const component = TestUtils.renderIntoDocument(
+      <Panel item={item} />
+    );
+    expect(component).toBeTruthy();
+
+    const node = ReactDOM.findDOMNode(component);
+    const block = node.querySelector('.card-block');
+
+    expect(block).toBeTruthy();
+  });
+});
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/widgets/feed/Feed.js b/hubs/static/client/app/widgets/feed/Feed.js
new file mode 100644
index 0000000..af0b1c6
--- /dev/null
+++ b/hubs/static/client/app/widgets/feed/Feed.js
@@ -0,0 +1,7 @@
+import Widget from './Widget.jsx';
+
+
+// Don't use the ES6 "export default" construct:
+// http://stackoverflow.com/questions/40294870/module-exports-vs-export-default-in-node-js-and-es6
+
+module.exports = {Widget};
diff --git a/hubs/static/client/app/widgets/feed/Widget.jsx b/hubs/static/client/app/widgets/feed/Widget.jsx
new file mode 100644
index 0000000..5ee232f
--- /dev/null
+++ b/hubs/static/client/app/widgets/feed/Widget.jsx
@@ -0,0 +1,57 @@
+import React from 'react';
+import Feed from '../../components/feed/Feed.jsx';
+
+
+export default class Widget extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      items: this.props.items,
+      sse: true,
+    };
+    this.componentDidMount = this.componentDidMount.bind(this);
+    this.componentWillUnmount = this.componentWillUnmount.bind(this);
+    this.handleMessage = this.handleMessage.bind(this);
+    this.source = null;
+  }
+
+  componentDidMount() {
+    // If it wasn't instantiated with a url or an error happened, bail
+    if (!this.props.url || !this.state.sse) {
+      return;
+    }
+    this.source = (!!window.EventSource) ? new EventSource(this.props.url) : null;
+    if (!this.source) {
+      return;
+    }
+    this.source.addEventListener('error', () => {
+      this.state.sse = false;
+    }, false);
+    this.source.onmessage = resp => {
+      this.handleMessage(JSON.parse(resp.data));
+    };
+  }
+
+  componentWillUnmount() {
+    if (this.source) { this.source.close(); }
+  }
+
+  handleMessage(msg) {
+    if (this.state.items.length >= this.props.options.messageLimit) {
+      this.state.items.pop();
+    }
+    this.state.items.unshift(msg);
+    this.setState({items: this.state.items});
+  }
+
+  render() {
+    return (
+        <Feed items={this.state.items} {...this.props} />
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/webpack.config.js b/hubs/static/client/webpack.config.js
index f197a0e..532e978 100644
--- a/hubs/static/client/webpack.config.js
+++ b/hubs/static/client/webpack.config.js
@@ -9,7 +9,7 @@ const PATHS = {
 const config = {
     entry: {
         Hubs: path.join(PATHS.app, 'core', 'Hubs.js'),
-        Feed: path.join(PATHS.app, 'widgets', 'feed', 'Feed.jsx'),
+        Feed: path.join(PATHS.app, 'widgets', 'feed', 'Feed.js'),
         Halp: path.join(PATHS.app, 'widgets', 'halp', 'Halp.js')
     },
     output: {
